#!/usr/bin/env python
import imp
import warnings
import os
import sys
from assert_exists import assert_exists
from public import public
from tolist import tolist


@public
def load_module(name, path=None):
    """imp.load_module replacement
    todo: isfile, isdir
    """
    if name:
        name = str(name)
    asname = name
    if name in sys.modules.keys():  # already loaded
        return sys.modules[name]
    if path:
        if isinstance(path, list):
            pass
            # modpath = path
        else:
            path = str(path)
            assert_exists(path)
            if os.path.isdir(path):
                path = [path]
            if not isinstance(path, list) and os.path.isfile(path):
                asname = os.path.basename(path).replace(".py", "")
                path = [os.path.dirname(path)]
    else:
        path = [os.getcwd()]
    # path = [] # python2 default
    # path = None # python3

    try:
        t = imp.find_module(asname, path)
    except Exception:
        return
    warnings.simplefilter("ignore", RuntimeWarning)
    warnings.simplefilter("ignore", ImportWarning)
    syspath = sys.path
    if path:
        sys.path += tolist(path)
    module = imp.load_module(name, *t)
    sys.path = syspath
    return module
